﻿/**
 * ...
 * @author Georg Graf
 */

package com.georg.tools
{

	public class ComplexNumber 
	{
		public var re:Number;
		public var im:Number;
		
		public function ComplexNumber(re:Number, im:Number) 
		{
			this.re = re;
			this.im = im;
		}
		
		public function clone():ComplexNumber
		{
			return new ComplexNumber(re, im);
		}
		
		public function toString():String
		{
			return "(" + re + "; " + im + ")";
		}
		
		public function add( cn:ComplexNumber):ComplexNumber
		{
			return new ComplexNumber(this.re + cn.re, this.im + cn.im);
		}
		
		public function subtract(cn:ComplexNumber):ComplexNumber
		{
			return new ComplexNumber(this.re - cn.re, this.im - cn.im);
		}
		
		public function multiply(cn:ComplexNumber):ComplexNumber
		{
			return new ComplexNumber(	(this.re * cn.re - this.im * cn.im), 
										(this.re * cn.im + this.im * cn.re));
		}
		
		public function divide(cn:ComplexNumber):ComplexNumber
		{
			return new ComplexNumber(	(this.re * cn.re + this.im * cn.im) / (cn.re * cn.re + cn.im * cn.im), 
										(this.im * cn.re - this.re * cn.im) / (cn.re * cn.re + cn.im * cn.im));
		}
		
		public function power(level:int = 2):ComplexNumber
		{
			var cn:ComplexNumber = clone();
			
			for (var i:int = 1; i < level; i++)
				cn = multiply(cn); 
				
			return cn;
		}
		
		public function abs():Number
		{
			return Math.sqrt(re * re + im * im);
		}
		
		public function phi():Number
		{
			return Math.asin(this.im / this.re);
		}
		
	}
}